;////////////////////////////////////////////////
;Colour Test v1.2         
; modified and commented by Cye Freeman 
;									a.k.a Happy_Dude
;////////////////////////////////////////////////////
;
; A 6 digit display is controlled by the joystick.
; Shows the colour that corresponds to the score number 
;
;4/8/03 - Added a sound function. Frequency rises and 
;	falls with the score. Only 31 possible freq's
;	so I want to make the other 2 registers do something
;5/8/03 - Fixed the decrease routine with some help at 
;	AtariAge. THANKS Manuel and Sheddy :)
;
;////////////////////////////////////////////////////
;
; My advice to anyone starting out in 2600 programining
; is to do something like this. Find a undercommented piece
; of code and make it your own. Modifiy and comment it.
; If you can find an old peice like this that had hex values
; instead of register names all the better :)
;
; DISCLAIMER:
; I'm a newbie myself so my comments here are far from law
; I'v also been know to be outright wrong on occasions :P
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


; Original header
;////////////////////////////////////////////////
; Subject: Re: [stella] 6 digit score display and other ramblings
; From: Robin Harbron <macbeth@Quetico.tbaytel.net>
; Date: Sun, 15 Mar 1998 23:48:21 -0500
;////////////////////////////////////////////////////
	
	processor 6502
	#include vcs.h

	
;////////////////////////////////////////////////
; R A M
;////////////////////////////////////////////////////
	
	SEG.U VAR
	org $80
score    		ds 8		; Score ... 
ptr0     		ds 2		; 6*16bit pointers
ptr1      		ds 2		;
ptr2      		ds 2		;
ptr3      		ds 2		;
ptr4      		ds 2		;
ptr5      		ds 2		;
tmp      		ds 2		; holds a pointer
count1    		ds 1		; line counter
debounce 		ds 1		; holds frame info
Colour	 		ds 1		; current colour
delay			ds 1		; sound duration
freq			ds 1		; Sound frequency
	SEG

	org $F000

.Reset
	sei						; Disable interupts
	cld						; Clear decimal
;////////////////////////////////////////////////
;  C L E A R   A L L
;////////////////////////////////////////////////////
	ldx #$FF			
	txs				
	lda #0				
.ClearMem
	sta 0,X				
	dex				
	bne .ClearMem	
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
	lda #0
	sta Colour
	sta COLUBK
	lda #10
	sta debounce
	lda #31
	sta freq

;////////////////////////////////////////////////
; This stuff isn't needed anymore
;////////////////////////////////////////////////////
;initialize score value
;	ldx #5
;	lda #0 ;5 or greater
;clr1
;	sta score
;	dex
;	bpl clr1

;clear data pointers
;         ldx #11
;         lda #0
;clr2     sta ptr0,x
;         dex
;         bpl clr2
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

	lda #1
	sta CTRLPF			; Reflected playfeild
	lda #0				; 0 = input
	sta SWACNT			; joystick inputs
	sta WSYNC
	ldy #3				; 3 loops to position P0 in center of screen
pos0
	dey
	bne pos0
	sta RESP0			; Reset Player0. Horizontal positioning....

	
main		
         
	lda #2				; Bit 7
	sta VSYNC			; Turns on Vert sync
	sta VBLANK			; and Vblank while we're at it
	sta WSYNC
	dec debounce		; decreses debounces :lol:
	lda #15				; White in NTSC or PAL
	sta COLUP0
	sta COLUP1
	sta VSYNC
	sta WSYNC
	sta VSYNC
	sta WSYNC
	lda #0			
	sta VSYNC			; Turn Vsync off


	ldy #37
doVBLANK 
	sta WSYNC
	dey
	bne doVBLANK
	sty VBLANK			; y now being 0 saves us a load

	lda #227			; set timer for 227*64 colour clocks
	sta TIM64T			; I like this bit of code :D

startscore
;make pointers to num data
;////////////////////////////////////////////////
; S E T   P O I N T E R S
;////////////////////////////////////////////////////
; You know your having a good day when you understand
; whats happening here :o
; N.B They're all my comments (ie: I'm the one to blame ;) )
	ldx #5
	ldy #10
loop2
	lda score,x					; Score,5 101 (byte 5 of score not "5" as illustrated)
	asl 						; asl = 010 carry1
	asl 						; asl = 001 carry0
	asl 						; asl = 000 carry1 
	adc #<zero					; add with carry into A (high byte)
	sta ptr0,y					; stored in pointer 0,10 (or 1st byte in pointer 5)
	lda #0						; clear a for some reason
	adc #>zero					; add with carry (low byte)
	sta ptr0+1,y				; store in pointer 5 2nd byte
	dey							; index of pointers
	dey							; minus 2 (because of the 2 writes)
	dex							
	bpl loop2					


	lda #3
	sta NUSIZ0
	sta NUSIZ1 					; 3 copies close
	sta WSYNC


	ldx #22
blah2		; nice lable :P
	dex
	bne blah2
	sta RESP0					; Positioning player 0 again
	sta WSYNC
	ldx #22
blah1
	dex
	bne blah1
	nop
	sta RESP1					; and now Player 1 gets the RESP
	sta HMCLR					; Clear all motion regs
	lda #$A0 					; 2 more than below
	sta HMP1					; set horizontal position
	lda #$C0 
	sta HMP0					
	sta WSYNC
	sta HMOVE					; release motion registers
	sta WSYNC

;draw score
	lda #7						; basicaly the height of the numbers
	sta count1					

	ldx #10
pause1
	dex
	bne pause1					; kill some time
	nop
	nop
	nop							; kill more time

;////////////////////////////////////////////////
; D R A W   R O U T I N E
;////////////////////////////////////////////////////
; the magical bit ;)	
; just loading pointers into ram and writing them

mainloop 
	ldy count1   ;3				current line
	lda (ptr0),y ;5 			load line from pointer 0
	sta GRP0     ;3 = 11		we're writing graphics to the screen, WEEEEEEE
	bit $00		 ;3 =  3		
	lda (ptr1),y ;5
	sta GRP1     ;3				write pointer 1
	lda (ptr5),y ;5
	tax          ;2				store pointer at a in x
	txs          ;2				Put pointer on the stack
	lda (ptr2),y ;5
	sta tmp      ;3				pointer 2 in temp
	lda (ptr3),y ;5
	tax          ;2				a into x again
	lda (ptr4),y ;5 = 37
	ldy tmp      ;3				load pointer 2 into y 
	sty GRP0     ;3				write pointer 2
	stx GRP1     ;3				write pointer 3			
	sta GRP0     ;3				write pointer 4
	tsx          ;2				put stack pointer (5) in x
	stx GRP1     ;3 = 17		write pointer 5
	dec count1   ;5
	bpl mainloop ;3 =  8
;\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
	
	lda #0
	sta GRP0
	sta GRP1				; Kill player graphics

	sta WSYNC
	sta WSYNC
	sta WSYNC				
	lda Colour
	sta WSYNC				; Give the score some space to breath
	sta COLUBK				; then set the background to the current colour


endoframe 
	lda INTIM				; read timer
	bne endoframe			; until it's finished
	sta WSYNC


;30 lines of overscan
	lda #35
	sta TIM64T				; start the timer (yet again)

    lda debounce			; has it been 10 frames yet
	bne .wait          		; no? then wait.
	lda #10					; else
	sta debounce			; reset debounce
	lda #%00010000 			; Joystick Down?
	bit SWCHA
	bne .SkipMoveUp 		; no? Then skip it
	dec freq				; sound rises
	inc Colour				; increase colour
	lda Colour 				; because thats the whole point
	sta COLUBK				; Im aiming for :P
	lda $55					
	sta AUDV1				; set Channel 1 volume
	sta AUDC1				; and tone
	lda freq				; and
	sta AUDF1 				; custom frequency
	lda #5
	sta delay				; frames to play sound
;increase score
	ldx #5
scloop1
	inc score,x				; increase score,5
	lda score,x				
	cmp #10					; is it 10?
	bne scdone				; no? then we're done here
	lda #0					; yes? then zero it
	sta score,x				
	dex						; and move on to the next byte
	bpl scloop1
scdone
.SkipMoveUp 




.SkipMoveUp
	LDA #%00100000 			; Down?
	BIT SWCHA
	BNE .SkipMoveDown
	inc freq				; sound falls
	dec Colour
	lda Colour 
	sta COLUBK
;decrease score
; Working Yaaaaay
	lda $55
	sta AUDV1
	sta AUDC1
	lda freq
	sta AUDF1 
	lda #3					; less of a delay while decreasing
	sta delay				; just to diferentiate
	ldx #5 
scloop2  
   dec score,x            	; decrease score 
   ;lda score,x 
   ;cmp #0               	; is it 0 
   bpl scdone2           	; no? then move on 
   lda #9              		; yes? then make it 9
   sta score,x 
   dex                  	; and the next number is 
   bpl scloop2            	; decreased ? 
scdone2 
.SkipMoveDown
	
.wait
; check if sound has finished
	ldx delay
	bne .buzz				; no? then keep buzzing
	lda $00					; yes? clear all audio registers
	sta AUDV1
	sta AUDF1
	sta AUDC1
.buzz	

cont     
	lda INTIM 				;wait until overscan is over
	bne cont
	nop
	nop
	sta WSYNC
	lda $00
	sta COLUBK
	dec delay
	jmp main
	
	
;////////////////////////////////////////////////
; G R A P H I C S
;////////////////////////////////////////////////////
zero     .byte %00111100
         .byte %01100010
         .byte %01010010
         .byte %01010010
         .byte %01001010
         .byte %01001010
         .byte %01000110
         .byte %00111100

one      .byte %01111110
         .byte %00011000
         .byte %00011000
         .byte %00011000
         .byte %00011000
         .byte %00011000
         .byte %00111000
         .byte %00011000

two      .byte %01111110
         .byte %00100000
         .byte %00010000
         .byte %00001000
         .byte %00000100
         .byte %00000010
         .byte %01000010
         .byte %00111100

three    .byte %00111100
         .byte %01000010
         .byte %00000010
         .byte %00011100
         .byte %00011100
         .byte %00000010
         .byte %01000010
         .byte %00111100

four     .byte %00001100
         .byte %00001100
         .byte %00001100
         .byte %01111110
         .byte %01001100
         .byte %00101100
         .byte %00011100
         .byte %00001100

five     .byte %00011000
         .byte %01100100
         .byte %00000010
         .byte %00000010
         .byte %01100100
         .byte %01011000
         .byte %01000000
         .byte %01111110

six      .byte %00111100
         .byte %01000010
         .byte %01000010
         .byte %01111100
         .byte %00100000
         .byte %00010000
         .byte %00001000
         .byte %00000100

seven    .byte %00001000
         .byte %00001000
         .byte %00001000
         .byte %00000100
         .byte %00000100
         .byte %00000010
         .byte %00000010
         .byte %01111110

eight    .byte %00111100
         .byte %01000010
         .byte %01000010
         .byte %00111100
         .byte %00111100
         .byte %01000010
         .byte %01000010
         .byte %00111100

nine     .byte %00111100
         .byte %00000010
         .byte %00000010
         .byte %00000010
         .byte %00111110
         .byte %01000010
         .byte %01000010
         .byte %00111100
         
;////////////////////////////////////////////////
; I N T E R U P T   V E C T O R S
;////////////////////////////////////////////////////         
	org $FFFA
    .word .Reset           ; NMI
    .word .Reset           ; RESET
    .word .Reset           ; IRQ